package com.sxt.chat;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.List;

public class MyChannel implements Runnable{
	private DataInputStream dis;
	private DataOutputStream dos;
	private boolean flag;
	public MyChannel() {
		this.flag = true;
	}
	public MyChannel(Socket socket) {
		this();
		try {
			dis = new DataInputStream(socket.getInputStream());
			dos = new DataOutputStream(socket.getOutputStream());
		} catch (IOException e) {
			this.flag = false;
			e.printStackTrace();
			CloseUtil.closeAll(dos,dis);
			
		}
	}
	
	
	public String receive() {
		String str = null;
		try {
			str = dis.readUTF();
		} catch (IOException e) {
			this.flag = false;
			e.printStackTrace();
			CloseUtil.closeAll(dis,dos);
			Server.list.remove(this);
		}
		return str;
	}
	
	
	public void send(String str) {
		//String str = receive();没有传参数多了这一行代码
		try {
			if(str != null && str.length() != 0) {
				dos.writeUTF(str);
			}
		} catch (IOException e) {
			this.flag = false;
			e.printStackTrace();
			CloseUtil.closeAll(dos,dis);
			Server.list.remove(this);
		}
	}
	
	public void sendOthers() {
		String str = this.receive();//没有传参数少了了这一行代码
		List<MyChannel> others = Server.list;
		
		for (MyChannel myChannel : others) {
			if (myChannel != this) {
				//myChannel.send();没有传参写法
				myChannel.send(str);
			}
		}
	}
	
	@Override
	public void run() {
		while(flag) {
			sendOthers();
		}
		
	}
}
