package com.sxt.chat;

import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.Scanner;

public class Send implements Runnable{
	private DataOutputStream dos;
	private Scanner input;
	private boolean flag;
	private String name;
	public Send() {
		this.flag = true;
		input = new Scanner(System.in);
		System.out.println("输入名称：");
		name = input.nextLine();
	}
	public Send(Socket socket) {
		this();
		try {
			dos = new DataOutputStream(socket.getOutputStream());
		} catch (IOException e) {
			this.flag = false;
			e.printStackTrace();
			CloseUtil.closeAll(dos,input,socket);
		}
	}
	
	private void send() {
		String str = input.nextLine();
		
		try {
			dos.writeUTF(name + "说：" + str);
		} catch (IOException e) {
			this.flag = false;
			e.printStackTrace();
			CloseUtil.closeAll(dos);
		}
		
	}
	
	@Override
	public void run() {
		while(flag) {
			send();
		}
		
	}
	
}